<!DOCTYPE html>
<html lang="fr">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="./assets/dist/app.css">
    <title>Academic Todolist</title>
</head>

<body class="flex flex-col h-screen overflow-auto">
    <main class="flex-grow h-full p-3 sm:p-10">
        <section class="container mx-auto">
            <h1 id="title" class="my-5 p-3 text-center text-5xl font-bold">
                <%= title %>
            </h1>
            <div class="flex sm:px-0 my-5 max-w-3xl mx-auto items-center justify-center space-x-3">
                <input type="text" name="libelle" id="newtodo" placeholder="Ajouter une tâche..." 
                class="flex-grow w-full h-10 p-3 rounded-lg bg-gray-50 shadow border-b border-gray-200"/>
                <button id="addTodo" onclick="addTodo()" for="libelle"
                class="flex-grow-0 h-10 p-2 rounded-lg bg-gray-50 shadow border-b border-gray-200 whitespace-nowrap focus:outline-none">Ajouter ＋</button>
                <button id="getTodos" onclick="getTodos()"
                class="flex-grow-0 h-10 p-2 rounded-lg bg-gray-50 shadow border-b border-gray-200 whitespace-nowrap focus:outline-none">Actualiser ⟲</button>
            </div>

            <div class="shadow overflow-hidden border-b border-gray-200 sm:rounded-lg max-w-3xl mx-auto">
                <table id="table" class="min-w-full divide-y divide-gray-200">
                    <thead class="bg-gray-50">
                        <tr class="flex">
                            <th scope="col" class="flex-grow-0 relative px-6 py-3">
                                <span class="sr-only">Select</span>
                            </th>
                            <th scope="col"
                                class="flex-grow-0 px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider">
                                Status
                            </th>
                            <th scope="col"
                                class="flex-grow px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider">
                                Title
                            </th>
                            <th scope="col" class="flex-grow-0 relative px-6 py-3">
                                <span class="sr-only">Edit</span>
                            </th>
                        </tr>
                    </thead>
                    <tbody id="todolist" class="bg-white divide-y divide-gray-200">
                        <% todolist.forEach(function(tache, index) { %>
                            <tr id="todo-<%= tache.id %>" class="flex cursor-move">
                                <td class="flex-grow-0 px-6 py-4 whitespace-nowrap">
                                    <% if (tache.status == "A_FAIRE") { %>
                                        <input type="checkbox" id="do-<%= tache.id %>" onchange="modifyTodo(<%= tache.id %>)">
                                    <% } else { %>
                                        <input type="checkbox" id="do-<%= tache.id %>" onchange="modifyTodo(<%= tache.id %>)" checked>
                                    <% } %>
                                </td>
                                <td class="flex-grow-0 px-6 py-4 whitespace-nowrap">
                                    <% if (tache.status == "A_FAIRE") { %>
                                        <span id="text-<%= tache.id %>"
                                            class="px-2 inline-flex text-xs leading-5 font-semibold rounded-full bg-green-100 text-green-800">
                                            To do
                                        </span>
                                    <% } else { %>
                                        <span id="text-<%= tache.id %>"
                                            class="px-2 inline-flex text-xs leading-5 font-semibold rounded-full bg-gray-100 text-gray-800">
                                            Done
                                        </span>
                                    <% } %>
                                </td>
                                <% if (tache.status == "A_FAIRE") { %>
                                    <td id="libelle-<%= tache.id %>" class="flex-grow px-6 py-4 whitespace-nowrap text-sm text-gray-500">
                                <% } else { %>
                                    <td id="libelle-<%= tache.id %>" class="flex-grow px-6 py-4 whitespace-nowrap text-sm text-gray-500 line-through">
                                <% } %>
                                    <%= tache.libelle %>
                                </td>
                                <td class="flex-grow-0 px-6 py-4 whitespace-nowrap text-right text-sm font-medium">
                                    <a class="text-indigo-600 hover:text-indigo-900 cursor-pointer" onclick="deleteTodo(<%= tache.id %>)"><span class='supprimer'>✕</span></a>
                                </td>
                            </tr>
                        <% }); %>
                    </tbody>
                </table>
            </div>
        </section>
    </main>

    <%- include('footer'); %>
</body>
</html>

<script>
    /////////////////////////////////////////////////
    //        API HANDLER / CALL FUNCTIONS         //
    /////////////////////////////////////////////////

    const input = document.getElementById('newtodo');
    const tableTodos = document.getElementById('todolist');

    let endpoint = 'http://localhost:3000/api/todos';

    function getTodos() {
        fetch(endpoint)
        .then(res => res.json())
        .then(data => {
            let line = "";
            data.forEach(todo => {
                if (todo.status == "A_FAIRE") {
                    status = "To do";
                    done = "";
                    color = "green";
                    checked = "";
                } else {
                    status = "Done";
                    done = "line-through";
                    color = "gray";
                    checked = "checked='true'";
                }
                line += `<tr id="todo-${todo.id}" class="flex cursor-move">
                                <td class="flex-grow-0 px-6 py-4 whitespace-nowrap">
                                    <input type="checkbox" id="do-${todo.id}" onchange="modifyTodo(${todo.id})" ${checked}>
                                </td>
                                <td class="flex-grow-0 px-6 py-4 whitespace-nowrap">
                                    <span id="text-${todo.id}" class="px-2 inline-flex text-xs leading-5 font-semibold rounded-full bg-${color}-100 text-${color}-800">
                                        ${status}
                                    </span>
                                </td>
                                <td id="libelle-${todo.id}" class="flex-grow px-6 py-4 whitespace-nowrap text-sm text-gray-500 ${done}">
                                    ${todo.libelle}
                                </td>
                                <td class="flex-grow-0 px-6 py-4 whitespace-nowrap text-right text-sm font-medium">
                                    <a class="text-indigo-600 hover:text-indigo-900 cursor-pointer" onclick="deleteTodo(${todo.id})"><span class='supprimer'>✕</span></a>
                                </td>
                            </tr>`
            });
            tableTodos.innerHTML = line;
            dragMe();
        })
        .catch((err) => {
            // console.log(err)
        });
    }

    function addTodo() {
        fetch(endpoint, {
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json'
            },
            method: 'post',
            body: JSON.stringify({"libelle": input.value})
        })
        .then(res => res.json())
        .then(data => {
            let line = `<tr id="todo-${data.insertId}" class="flex cursor-move">
                            <td class="flex-grow-0 px-6 py-4 whitespace-nowrap">
                                <input type="checkbox" id="do-${data.insertId}" onchange="modifyTodo(${data.insertId})">
                            </td>
                            <td class="flex-grow-0 px-6 py-4 whitespace-nowrap">
                                <span id="text-${data.insertId}" class="px-2 inline-flex text-xs leading-5 font-semibold rounded-full bg-green-100 text-green-800">
                                    To do
                                </span>
                            </td>
                            <td id="libelle-${data.insertId}" class="flex-grow px-6 py-4 whitespace-nowrap text-sm text-gray-500">
                                ${input.value}
                            </td>
                            <td class="flex-grow-0 px-6 py-4 whitespace-nowrap text-right text-sm font-medium">
                                <a class="text-indigo-600 hover:text-indigo-900 cursor-pointer" onclick="deleteTodo(${data.insertId})"><span class='supprimer'>✕</span></a>
                            </td>
                        </tr>`
            tableTodos.innerHTML += line;
            input.value = '';
            dragMe();
            modifyTodo(data.insertId, {ordre: true});
        })
        .catch((err) => {
            // console.log(err)
        });
    }

    function modifyTodo(id, params = undefined) {
        let checkbox = document.getElementById('do-'+id);
        if (params === undefined) {
            params = {status: checkbox.checked};
        }
        fetch(endpoint+'/'+id, {
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json'
            },
            method: 'PATCH',
            body: JSON.stringify(params)
        })
        .then(res => res.json())
        .then(data => {
            if (params.status !== undefined) {
                let libelle = document.getElementById('libelle-'+id);
                libelle.classList.toggle('line-through')
    
                let todoClasses = ['bg-green-100', 'text-green-800']
                let doneClasses = ['bg-gray-100', 'text-gray-800']
    
                let span = document.getElementById('text-'+id);
                if (span.innerText == "To do") {
                    span.innerText = "Done"
                    span.classList.remove(...todoClasses)
                    span.classList.add(...doneClasses)
                    checkbox.setAttribute('checked', true);
                } else {
                    span.innerText = "To do"
                    span.classList.remove(...doneClasses)
                    span.classList.add(...todoClasses)
                    checkbox.setAttribute('checked', false);
                }
            }
            // dragMe();
        })
        .catch((err) => {
            // console.log(err)
        });
    }

    function deleteTodo(id) {
        fetch(endpoint+'/'+id, {
            headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json'
            },
            method: 'delete',
            body: JSON.stringify()
        })
        .then(res => res.json())
        .then(data => {
            let node = document.getElementById('todo-'+id);
            tableTodos.removeChild(node);
            dragMe();
        })
        .catch((err) => {
            // console.log(err)
        });
    }




    
    //////////////////////////////////
    //        DRAG AND DROP         //
    //////////////////////////////////

    // Following code was mainly written by https://github.com/phuoc-ng/html-dom

    document.addEventListener('DOMContentLoaded', dragMe());

    function dragMe() {
        const table = document.getElementById('table');

        let draggingEle;
        let draggingRowIndex;
        let placeholder;
        let list;
        let isDraggingStarted = false;

        // The current position of mouse relative to the dragging element
        let x = 0;
        let y = 0;

        // Swap two nodes
        const swap = function (nodeA, nodeB) {
            const parentA = nodeA.parentNode;
            const siblingA = nodeA.nextSibling === nodeB ? nodeA : nodeA.nextSibling;

            // Move `nodeA` to before the `nodeB`
            nodeB.parentNode.insertBefore(nodeA, nodeB);

            // Move `nodeB` to before the sibling of `nodeA`
            parentA.insertBefore(nodeB, siblingA);
        };

        // Check if `nodeA` is above `nodeB`
        const isAbove = function (nodeA, nodeB) {
            // Get the bounding rectangle of nodes
            const rectA = nodeA.getBoundingClientRect();
            const rectB = nodeB.getBoundingClientRect();

            return (rectA.top + rectA.height / 2 < rectB.top + rectB.height / 2);
        };

        const cloneTable = function () {
            const rect = table.getBoundingClientRect();
            const width = parseInt(window.getComputedStyle(table).width);

            list = document.createElement('div');
            list.classList.add('clone-list');
            list.style.position = 'absolute';
            list.style.left = `${rect.left}px`;
            list.style.top = `${rect.top}px`;
            table.parentNode.insertBefore(list, table);

            // Hide the original table
            table.style.visibility = 'hidden';

            table.querySelectorAll('tr').forEach(function (row) {
                // Create a new table from given row
                const item = document.createElement('div');
                item.classList.add('draggable');

                const newTable = document.createElement('table');
                newTable.setAttribute('class', 'clone-table bg-white border-gray-200 border-b');
                newTable.style.width = `${width}px`;

                const newRow = document.createElement('tr');
                const cells = [].slice.call(row.children);
                cells.forEach(function (cell) {
                    const newCell = cell.cloneNode(true);
                    newCell.style.width = `${parseInt(window.getComputedStyle(cell).width)}px`;
                    newRow.appendChild(newCell);
                    newCell.classList.add('align-top')
                });

                newTable.appendChild(newRow);
                item.appendChild(newTable);
                list.appendChild(item);
                if (list.firstChild === item) {
                    newTable.classList.add('bg-gray-50');
                }
            });
        };

        const mouseDownHandler = function (e) {
            // Get the original row
            const originalRow = e.target.parentNode;
            draggingRowIndex = [].slice.call(table.querySelectorAll('tr')).indexOf(originalRow);

            // Determine the mouse position
            x = e.clientX;
            y = e.clientY;

            // Attach the listeners to `document`
            document.addEventListener('mousemove', mouseMoveHandler);
            document.addEventListener('mouseup', mouseUpHandler);
        };

        const mouseMoveHandler = function (e) {
            if (!isDraggingStarted) {
                isDraggingStarted = true;

                cloneTable();

                draggingEle = [].slice.call(list.children)[draggingRowIndex];
                draggingEle.classList.add('dragging');

                // Let the placeholder take the height of dragging element
                // So the next element won't move up
                placeholder = document.createElement('div');
                placeholder.classList.add('placeholder');
                draggingEle.parentNode.insertBefore(placeholder, draggingEle.nextSibling);
                placeholder.style.height = `${draggingEle.offsetHeight}px`;
            }

            // Set position for dragging element
            draggingEle.style.position = 'absolute';
            draggingEle.style.top = `${draggingEle.offsetTop + e.clientY - y}px`;
            draggingEle.style.left = `${draggingEle.offsetLeft + e.clientX - x}px`;

            // Reassign the position of mouse
            x = e.clientX;
            y = e.clientY;

            // The current order
            // prevEle
            // draggingEle
            // placeholder
            // nextEle
            const prevEle = draggingEle.previousElementSibling;
            const nextEle = placeholder.nextElementSibling;

            // The dragging element is above the previous element
            // User moves the dragging element to the top
            // We don't allow to drop above the header
            // (which doesn't have `previousElementSibling`)
            if (prevEle && prevEle.previousElementSibling && isAbove(draggingEle, prevEle)) {
                // The current order    -> The new order
                // prevEle              -> placeholder
                // draggingEle          -> draggingEle
                // placeholder          -> prevEle
                swap(prevEle, draggingEle);
                swap(prevEle, placeholder);
                // console.log("Moving row "+draggingEle.querySelector('input').id+" before "+prevEle.querySelector('input').id);
                modifyTodo(draggingEle.querySelector('input').id.split('-')[1], {swap_id: prevEle.querySelector('input').id.split('-')[1]});
                return;
            }

            // The dragging element is below the next element
            // User moves the dragging element to the bottom
            if (nextEle && isAbove(nextEle, draggingEle)) {
                // The current order    -> The new order
                // draggingEle          -> nextEle
                // placeholder          -> placeholder
                // nextEle              -> draggingEle
                swap(nextEle, placeholder);
                swap(nextEle, draggingEle);
                // console.log("Moving row "+draggingEle.querySelector('input').id+" after "+nextEle.querySelector('input').id);
                modifyTodo(draggingEle.querySelector('input').id.split('-')[1], {swap_id: nextEle.querySelector('input').id.split('-')[1]});
            }
        };

        const mouseUpHandler = function () {
            // Remove the placeholder
            placeholder && placeholder.parentNode.removeChild(placeholder);

            draggingEle.classList.remove('dragging');
            draggingEle.style.removeProperty('top');
            draggingEle.style.removeProperty('left');
            draggingEle.style.removeProperty('position');

            // Get the end index
            const endRowIndex = [].slice.call(list.children).indexOf(draggingEle);

            isDraggingStarted = false;

            // Remove the `list` element
            list.parentNode.removeChild(list);

            // Move the dragged row to `endRowIndex`
            let rows = [].slice.call(table.querySelectorAll('tr'));
            draggingRowIndex > endRowIndex
                ? rows[endRowIndex].parentNode.insertBefore(rows[draggingRowIndex], rows[endRowIndex])
                : rows[endRowIndex].parentNode.insertBefore(rows[draggingRowIndex], rows[endRowIndex].nextSibling);

            // Bring back the table
            table.style.removeProperty('visibility');

            // Remove the handlers of `mousemove` and `mouseup`
            document.removeEventListener('mousemove', mouseMoveHandler);
            document.removeEventListener('mouseup', mouseUpHandler);
        };

        table.querySelectorAll('tr').forEach(function (row, index) {
            // Ignore the header
            // We don't want user to change the order of header
            if (index === 0) {
                return;
            }

            let cols = row.querySelectorAll('td');
            cols.forEach((col, index) => {
                if (index != 0 && index != cols.length-1) {
                    col.classList.add('draggable');
                    try {
                        col.removeEventListener('mousedown', mouseDownHandler);
                    } catch (err) {
                        console.log(err);
                    }
                    col.addEventListener('mousedown', mouseDownHandler);
                }
            })
        });
    }
</script>